;(function() {
    var list = [
        // base
        'getSystemInfo',
        'getSystemInfoSync',
        // route
        'switchTab',
        'reLaunch',
        'redirectTo',
        'navigateTo',
        'navigateBack',
        // ui
        'showToast',
        'hideToast',
        'showLoading',
        'hideLoading',
        'showModal',
        'showActionSheet',
        'setNavigationBarTitle',
        'setNavigationBarColor',
        'showNavigationBarLoading',
        'hideNavigationBarLoading',
        'setTabBarItem',
        'setTabBarStyle',
        'hideTabBar',
        'showTabBar',
        'setTabBarBadge',
        'removeTabBarBadge',
        'showTabBarRedDot',
        'hideTabBarRedDot',
        'onTabBarMidButtonTap',
        'setBackgroundColor',
        'setBackgroundTextStyle',
        'createAnimation',
        'pageScrollTo',
        'onWindowResize',
        'offWindowResize',
        'loadFontFace',
        'startPullDownRefresh',
        'stopPullDownRefresh',
        'createSelectorQuery',
        'createIntersectionObserver',
        'createMediaQueryObserver',
        'getMenuButtonBoundingClientRect',
        'showTopWindow',
        'showLeftWindow',
        'showRightWindow',
        'hideTopWindow',
        'hideLeftWindow',
        'hideRightWindow',
        'getTopWindowStyle',
        'getLeftWindowStyle',
        'getRightWindowStyle',
        'setTopWindowStyle',
        'setLeftWindowStyle',
        'setRightWindowStyle',
        'getLocale',
        'setLocale',
        // network
        'request',
        'uploadFile',
        'downloadFile',
        'connectSocket',
        'createTCPSocket',
        'createUDPSocket',
        // storage
        'setStorage',
        'setStorageSync',
        'getStorage',
        'getStorageSync',
        'getStorageInfo',
        'getStorageInfoSync',
        'removeStorage',
        'removeStorageSync',
        'clearStorage',
        'clearStorageSync'
    ];
    for (var i=0; i<list.length; i++) {
        var name = list[i];
        api[name] = wrapperApi(name);
    }
    function wrapperApi(name) {
        return function(parameters) {
            var param = parameters || {};
            param.apiMethodName = name;
            if (name.slice(-4) == 'Sync') {
                return api.invokeApiSync(param);
            } else {
                api.invokeApi(param, function(ret, err){
                    if (ret && typeof param.success === 'function') {
                        param.success(ret);
                    } else if (err && typeof param.fail === 'function') {
                        param.fail(err);
                    }
                    typeof param.complete === 'function' && param.complete(ret, err);
                });
            }
        };
    };
})();
